﻿using System.ComponentModel;
using System.Windows.Controls;
using System.Windows.Data;
using Infragistics.Controls.Editors;

namespace SliderThumbAddingSample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            LayoutRoot.DataContext = new MyClass();

            rangeSlider.MinValue = -20;
            rangeSlider.MaxValue = 20;
        }

        private void setButton_Clicked(object sender, System.Windows.RoutedEventArgs e)
        {
            rangeSlider.Thumbs.Clear();

            XamSliderThumb<double> thumb = new XamSliderThumb<double>();
            thumb.InteractionMode = SliderThumbInteractionMode.Lock;
            thumb.SetBinding(XamSliderThumb<double>.ValueProperty, new Binding("Thumb3") { Mode = BindingMode.TwoWay });
            thumb.Name = "Thumb3";
            rangeSlider.Thumbs.Add(thumb);

            thumb = new XamSliderThumb<double>();
            thumb.InteractionMode = SliderThumbInteractionMode.Lock;
            thumb.SetBinding(XamSliderThumb<double>.ValueProperty, new Binding("Thumb2") { Mode = BindingMode.TwoWay });
            thumb.Name = "Thumb2";
            rangeSlider.Thumbs.Add(thumb);
            
            thumb = new XamSliderThumb<double>();
            thumb.InteractionMode = SliderThumbInteractionMode.Lock;
            thumb.SetBinding(XamSliderThumb<double>.ValueProperty, new Binding("Thumb1") { Mode = BindingMode.TwoWay });
            thumb.Name = "Thumb1";
            rangeSlider.Thumbs.Add(thumb);
        }
    }

    public class MyClass : INotifyPropertyChanged
    {
        public MyClass()
        {
            // These will work
            //Thumb1 = 0;
            //Thumb2 = 1;
            //Thumb3 = 12;

            // These don't work
            Thumb1 = -3;
            Thumb2 = -1;
            Thumb3 = 12;
        }

        private double _thumb1;
        public double Thumb1
        {
            get { return _thumb1; }
            set { _thumb1 = value; OnPropertyChanged("Thumb1"); }
        }

        private double _thumb2;
        public double Thumb2
        {
            get { return _thumb2; }
            set { _thumb2 = value; OnPropertyChanged("Thumb2"); }
        }

        private double _thumb3;
        public double Thumb3
        {
            get { return _thumb3; }
            set { _thumb3 = value; OnPropertyChanged("Thumb3"); }
        }
        
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
